#!/bin/bash
accumsize=${1}
top=$(($accumsize-1))
high=$(($top * 7/10))
low=$(($top * 7/20))
double=$(($accumsize*2))

scoredir=test-s${accumsize}

echo
mkdir "${scoredir}"

if [[ $? != 0 ]]; then
	echo Aborted!  Nothing done.
	echo
	exit
fi

echo Compiling xoroshiro-longiter64.c for word size of ${accumsize} ...
gcc -o "${scoredir}/maxiter" "xoroshiro-longiter64.c" -O3 -DACCUM_SIZE=${accumsize}

if [[ $? != 0 ]]; then
	echo Aborted!  Compile error.
	echo
	exit
fi

echo Launching $top processes to brute force find max iterations of Xoroshiro${double}+ random generator ...
for a in `seq 1 $top`; do
#	niceness=$((${a}%2 + 11))
#	echo $a  $niceness
	nice -11 stdbuf -o L "${scoredir}/maxiter" ${a} >"${scoredir}/maxiter-s${accumsize}-a${a}.out" &
done

date +"%F %T"
