#!/bin/bash
accumsize=$(($1))
echo
#echo ${1}
#echo ${2}
#echo ${accumsize}
if [ "$accumsize" -lt "9" ]; then
	echo Aborted!  Size range 9-64.
	echo
	exit
fi

top=$(( $accumsize-1 ))
lowhalf=$(( $accumsize/2-1 ))
#highhalf=$(( $accumsize-$lowhalf ))
highhalf=$(( $accumsize/2+1 ))
double=$(( $accumsize*2 ))

scoredir=test-s${accumsize}

mkdir "${scoredir}"

if [[ $? != 0 ]]; then
	echo Aborted!  Nothing done.
	echo
	exit
fi

echo Compiling xoroshiro-quarteriter64.c for word size of ${accumsize} ...
gcc -o "${scoredir}/maxiter" "xoroshiro-quarteriter64.c" -O3 -DACCUM_SIZE=${accumsize}

if [[ $? != 0 ]]; then
	echo Aborted!  Compile error.
	echo
	exit
fi

echo Launching $highhalf processes to brute force find max iterations of Xoroshiro${double}+ random generator ...
for c in `seq 1 $highhalf`; do
#	niceness=$((${c}%2 + 11))
#	echo $c  $niceness
	nice -11 stdbuf -o L "${scoredir}/maxiter" ${c} >"${scoredir}/maxiter-s${accumsize}-c${c}.out" &
done

date +"%F %T"
