#include <limits.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>


//#define  ACCUM_SIZE  16   // Passed in as -D gcc parameter. (Min=9, Max=64) Bit width of generated random numbers.
//#define  CONSTANT_A  11   // Passed in as -D gcc parameter.
//#define  CONSTANT_B  2   // Passed in as -D gcc parameter.
//#define  CONSTANT_C  6   // Passed in as -D gcc parameter.

#define  ACCUM_MASK  (((1ULL<<(ACCUM_SIZE-1))-1)<<1|1)   // Bit of a shuffle to work on all 64 bits :)


// Seed the state array.  Seed MUST not be all zero.
static uint64_t  s[2] = {1, 0};


static inline  uint64_t rotl(uint64_t value, int shift) {
//	return (value << shift) | (value >> (sizeof(value) * CHAR_BIT - shift));
	return ((value << shift) | ((value & ACCUM_MASK) >> (ACCUM_SIZE - shift))) & ACCUM_MASK;
}


static uint64_t  next(void) {
	uint64_t  s0 = s[0];
	uint64_t  s1 = s[1];
//	uint64_t  result = (s0 + s1) >> 1;   // Remove lsb because not quite so random.
	uint64_t  result = (s0 + s1) & ACCUM_MASK;

	s1 ^= s0;
//	s[0] = rotl(s0, 55) ^ s1 ^ (s1 << 14);   // a, b  Preset for 63 bit results
//	s[1] = rotl(s1, 36);   // c
//	s[0] = rotl(s0, ((RESULT_SIZE)*56/64-1)|1) ^ s1 ^ (s1 << ((RESULT_SIZE)*14/64)) & ACCUM_MASK;   // a, b
//	s[1] = rotl(s1, ((RESULT_SIZE)*36/64)&-2);   // c    Note: 'a' is forced odd, and 'c' is forced even.
	s[0] = rotl(s0, CONSTANT_A) ^ s1 ^ (s1 << CONSTANT_B) & ACCUM_MASK;
	s[1] = rotl(s1, CONSTANT_C);

	return result;
}


//  Store as Little-Endian byte ordering.
int  main(int argc, char* argv[])
{
	uint64_t  random64;
	int  chunk = 0, i;
	uint8_t  k = 0;


	// Print some randomness
	while(1)
	{
		random64 = next() >> 1;   // Remove lsb because not quite so random.
//		printf( "%016lx ", random64 );

		if( chunk ) {  // Any remainder?
			k |= (random64 << chunk) & 0xff;   // Concatenate to full byte.
			chunk = 8 - chunk;   // Concatenating size.
			putchar( k );
//			printf( "%02x ", k );
		}

		while(chunk <= ((ACCUM_SIZE-1) - 8)) {   //  Stop at last full byte. (Bit group increments from base bit)
			k = random64 >> chunk;   // One byte.
			chunk += 8;
			putchar( k );
//			printf( "%02x ", k );
		}
//		printf("\n");

		k = random64 >> chunk;   // Any remainder.
		chunk = (ACCUM_SIZE-1) - chunk;  //  Remainder size.
//		printf( "%02x %04d ", k, chunk );
	}

	return 0;
}
